#!/usr/bin/env python

# MintDesktop
#	No Copyright (What for?) 
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; Version 2
# of the License.

try:
	import os
	import commands
	import sys
	import string
	import pygtk
	pygtk.require("2.0")
except Exception, detail:
	print detail
	pass
try:
	import gtk
	import gtk.glade
	import gettext
except Exception, detail:
	print detail
	sys.exit(1)


# i18n
gettext.install("messages", "locale") 

class MintDesktop:
	"""MintDesktop"""

	def __init__(self):
		# vars
		self.gladefile = '/usr/lib/linuxmint/mintDesktop-fluxbox/mintDesktop-fluxbox_frontend.glade'

		self.appName = "Fluxbox mintDesktop"
		self.appVersion = "0.2"
		
		gtk.glade.bindtextdomain(APPDOMAIN, LANGDIR)
		gtk.glade.textdomain(APPDOMAIN)

		# setup glade widget tree
		self.wTree = gtk.glade.XML(self.gladefile, domain='mintDesktop') 
		
		# create signal dictionary and connect
		self.wTree.get_widget("main_window").connect("destroy", gtk.main_quit)
		self.wTree.get_widget("button_cancel").connect("clicked", gtk.main_quit)
		self.wTree.get_widget("button_ok").connect("clicked", self.applyChanges)
		# set app title
		self.wTree.get_widget("main_window").set_title(self.appName)
		self.wTree.get_widget("font_tweak").connect("clicked", self.restore_splash, "font")
		self.wTree.get_widget("icon_tweak").connect("clicked", self.restore_splash, "icon")
		

		# i18n
		self.wTree.get_widget("label0").set_text(_("<big><b>Configure your desktop</b></big>"))
		self.wTree.get_widget("label0").set_use_markup(True)

		self.wTree.get_widget("label7").set_text(_("<b>Main</b>"))
		self.wTree.get_widget("label7").set_use_markup(True)

		self.wTree.get_widget("label8").set_text(_("<b>System Tweaks</b>"))
		self.wTree.get_widget("label8").set_use_markup(True)

		self.wTree.get_widget("label1").set_text(_("Restore Linux Mint Artwork"))

                self.wTree.get_widget("label3").set_text(_("Mplayer Video thumbnails settings for Thunar."))

		label1 = self.wTree.get_widget("label1")

		tooltips = gtk.Tooltips()

		tooltips.set_tip(label1, _("No Backups"))
		
		self.wTree.get_widget("label11").set_text(_("LCD System Font(Requires logout to Reset)."))

		label11 = self.wTree.get_widget("label11")

		tooltips = gtk.Tooltips()

		tooltips.set_tip(label11, _("Overwrites ~/.fonts.conf & No Backups"))
		
		self.wTree.get_widget("label12").set_text(_("Toggle Menu Icons."))
		
		self.wTree.get_widget("label4").set_text(_("Do you have a Windows network?(Reboot for changes to take effect)"))
		
	        self.wTree.get_widget("checkbox_gimp").set_label(_("The Gimp"))

		checkbox_gimp = self.wTree.get_widget("checkbox_gimp")

		tooltips = gtk.Tooltips()

		tooltips.set_tip(checkbox_gimp, _("Gimp Splash"))

		self.wTree.get_widget("checkbox_openoffice").set_label(_("OpenOffice"))

		checkbox_openoffice = self.wTree.get_widget("checkbox_openoffice")

		tooltips = gtk.Tooltips()

		tooltips.set_tip(checkbox_openoffice, _("OpenOffice Splash"))

		self.wTree.get_widget("checkbox_exaile").set_label(_("Exaile"))

		checkbox_exaile = self.wTree.get_widget("checkbox_exaile")

		tooltips = gtk.Tooltips()

		tooltips.set_tip(checkbox_exaile, _("Exaile Theme"))

		self.wTree.get_widget("thumbnail_enable").set_label(_("Enable"))

		thumbnail_enable = self.wTree.get_widget("thumbnail_enable")

		tooltips = gtk.Tooltips()

		tooltips.set_tip(thumbnail_enable, _("Needs Mplayer"))

		self.wTree.get_widget("thumbnail_disable").set_label(_("Disable"))

		thumbnail_disable = self.wTree.get_widget("thumbnail_disable")

		tooltips = gtk.Tooltips()

		tooltips.set_tip(thumbnail_disable, _("Clears thumbnail cache"))
	
		self.wTree.get_widget("checkbox_smb_browsing").set_label(_("Automatic Browsing"))		

		checkbox_smb_browsing = self.wTree.get_widget("checkbox_smb_browsing")

		tooltips = gtk.Tooltips()

		tooltips.set_tip(checkbox_smb_browsing, _("Automatically mounts network neighbourhoods in my Network folder"))

		self.wTree.get_widget("font_tweak").set_label(_("Enable/Disable"))

		self.wTree.get_widget("icon_tweak").set_label(_("Enable/Disable"))

		# Get the current configuration
		confGimp = commands.getoutput("gconftool-2 --get /apps/mintdesktop/gimp_splash")
		if (confGimp == "true"):
			self.wTree.get_widget("checkbox_gimp").set_active(1)
		confOpenoffice = commands.getoutput("gconftool-2 --get /apps/mintdesktop/openoffice_splash")
		if (confOpenoffice == "true"):
			self.wTree.get_widget("checkbox_openoffice").set_active(1)
                confExaile = commands.getoutput("gconftool-2 --get /apps/mintdesktop/exaile_theme")
		if (confExaile == "true"):
			self.wTree.get_widget("checkbox_exaile").set_active(1)
		confTrash = commands.getoutput("gconftool-2 --get /apps/nautilus/desktop/network_icon_visible")
		if (confTrash == "true"):
			self.wTree.get_widget("checkbox_trash").set_active(1)
                confThumbnail = commands.getoutput("gconftool-2 --get /apps/mintdesktop/thumbnails")
		if (confThumbnail == "true"):
			self.wTree.get_widget("thumbnail_enable").set_active(1)
		else:
			self.wTree.get_widget("thumbnail_disable").set_active(1)			
		home = os.environ.get("HOME")
		if (os.path.exists(home + "/.linuxmint/mintDesktop_smb_browsing")):
			self.wTree.get_widget("checkbox_smb_browsing").set_active(1)
		#if (os.path.exists(home + "/.linuxmint/mintDesktop_smb_sharing")):
		#	self.wTree.get_widget("checkbox_smb_sharing").set_active(1)
		#	config_file = open(home + "/.linuxmint/mintDesktop_smb_sharing")
		#	for config_item in config_file.readlines():
		#		if (string.find(config_item, "workgroup") == 0):
		#			array = string.split(config_item)
		#			if (len(array) == 2):
		#				(waste, workgroup) = string.split(config_item)
		#				self.wTree.get_widget("txt_workgroup").set_text(workgroup)
		
	def exitApp(self):
		gtk.main_quit()
		sys.exit(0)

	def applyChanges(self, widget): 
		gimp_selected = self.wTree.get_widget("checkbox_gimp").get_active()
		if (gimp_selected == True):
			os.system("gksu cp /usr/lib/linuxmint/mintDesktop-fluxbox/splashes/gimp/* /usr/share/gimp/2.0/images/")
			os.system("gconftool-2 --type bool --set /apps/mintdesktop/gimp_splash true")
		else:
			os.system("gconftool-2 --type bool --set /apps/mintdesktop/gimp_splash false")
		
		openoffice_selected = self.wTree.get_widget("checkbox_openoffice").get_active()
		if (openoffice_selected == True):
			os.system("gksu cp /usr/lib/linuxmint/mintDesktop-fluxbox/splashes/openoffice/* /usr/lib/openoffice/program/")
			os.system("gconftool-2 --type bool --set /apps/mintdesktop/openoffice_splash true")
		else:
			os.system("gconftool-2 --type bool --set /apps/mintdesktop/openoffice_splash false")
		
		exaile_selected = self.wTree.get_widget("checkbox_exaile").get_active()
		if (exaile_selected == True):
			os.system("gksu cp /usr/lib/linuxmint/mintDesktop-fluxbox/splashes/exaile/images/* /usr/share/exaile/images/ ")
			os.system("gksu cp /usr/lib/linuxmint/mintDesktop-fluxbox/splashes/exaile/pixmaps/* /usr/share/pixmaps/ ")	
			os.system("gconftool-2 --type bool --set /apps/mintdesktop/exaile_theme true")
		else:
			os.system("gconftool-2 --type bool --set /apps/mintdesktop/exaile_theme false")

		thumbnail_selected = self.wTree.get_widget("thumbnail_enable").get_active()
		if (thumbnail_selected == True):
			os.system("/usr/lib/linuxmint/mintDesktop-fluxbox/thumbnail/installer.sh")		
		else:
			os.system("/usr/lib/linuxmint/mintDesktop-fluxbox/thumbnail/uninstaller.sh")
			os.system("gconftool-2 --type bool --set /apps/mintdesktop/thumbnails false")

		home = os.environ.get("HOME")
		smb_browsing_selected = self.wTree.get_widget("checkbox_smb_browsing").get_active()
		if (smb_browsing_selected == True):
			os.system("touch " + home + "/.linuxmint/mintDesktop_smb_browsing")
		else:
			os.system("rm " + home + "/.linuxmint/mintDesktop_smb_browsing")
		#smb_sharing_selected = self.wTree.get_widget("checkbox_smb_sharing").get_active()
		#if (smb_sharing_selected == True):
		#	os.system("touch " + home + "/.linuxmint/mintDesktop_smb_sharing")
		#	workgroup = self.wTree.get_widget("txt_workgroup").get_text() 
		#	os.system("echo 'workgroup " + workgroup + "' > " + home + "/.linuxmint/mintDesktop_smb_sharing")
		#else:
		#	os.system("rm " + home + "/.linuxmint/mintDesktop_smb_sharing")
		gtk.main_quit()		
		sys.exit(0)	
	def restore_splash(self, widget, application):				
		if (application == "toggle"):
			os.system("/usr/lib/linuxmint/mintDesktop-fluxbox/desktopeffects/compiztoggle.sh") 
			self.wTree.get_widget("compiz_toggle").set_sensitive(True)	
		if (application == "font"):
			os.system("/usr/lib/linuxmint/mintDesktop-fluxbox/tweaks/fonts/fonttoggle.sh") 
			self.wTree.get_widget("font_tweak").set_sensitive(True)	
		if (application == "icon"):
			os.system("/usr/lib/linuxmint/mintDesktop-fluxbox/tweaks/menuicons/toggleicons.sh") 
			self.wTree.get_widget("icon_tweak").set_sensitive(True)	

	
# ---------- MAIN ----------

if __name__ == "__main__":
	APPDOMAIN='mintDesktop'
	LANGDIR='lang'
	# locale
	gtk.glade.bindtextdomain(APPDOMAIN, LANGDIR)
	gtk.glade.textdomain(APPDOMAIN)
	rec = MintDesktop()
	# run gui
	gtk.main()
