#!/bin/bash

confcheck () {
if [ ! -f $HOME/.mint-fm2/mint-fm2.conf ]
then
	if [ -f /usr/lib/linuxmint/mint-fm2/mint-fm2.conf ]
	then 
		cp /usr/lib/linuxmint/mint-fm2/mint-fm2.conf $HOME/.mint-fm2/mint-fm2.conf
	else
		zenity --error --text="mint-fm2 not installed!"
		exit 1
	fi
fi
}

geticon () {
icons=`cat $HOME/.mint-fm2/mint-fm2.conf | grep Icons | sed '/^#/ d' | cut -d ' ' -f2`
}

gettheme () {
icontheme=`cat $HOME/.mint-fm2/mint-fm2.conf | grep IconTheme | sed '/^#/ d' | cut -d ' ' -f2`
}

apply () {
if [ "$icons" = "true" ]
then
	rm $HOME/.mint-fm2/mint-fm2.conf.backup
	cp $HOME/.mint-fm2/mint-fm2.conf $HOME/.mint-fm2/mint-fm2.conf.backup
	sed 's/^Icons: true/Icons: false/g' $HOME/.mint-fm2/mint-fm2.conf.backup > $HOME/.mint-fm2/mint-fm2.conf
	rm $HOME/.fluxbox/menu.backup
	mv $HOME/.fluxbox/menu $HOME/.fluxbox/menu.backup
	cd /usr/lib/linuxmint/mint-fm2
	./mint-fm2-launcher
	cd	
else
	rm $HOME/.mint-fm2/mint-fm2.conf.backup
	cp $HOME/.mint-fm2/mint-fm2.conf $HOME/.mint-fm2/mint-fm2.conf.backup
	sed 's/^Icons: false/Icons: true/g' $HOME/.mint-fm2/mint-fm2.conf.backup > $HOME/.mint-fm2/mint-fm2.conf
	rm $HOME/.fluxbox/menu.backup
	mv $HOME/.fluxbox/menu $HOME/.fluxbox/menu.backup
	cd /usr/lib/linuxmint/mint-fm2
	./mint-fm2-launcher
	cd
fi
}

confcheck
geticon
apply

exit
